<template>
  <div>
    <div
        v-if="!isNew"
        class="row"
    >
      <div class="col-xs-6">
        <ObDatePickerConstructor
            :value="dataSource.eventData && dataSource.eventData.occurredAt"
            label="Дата и время создания"
            :is-time="true"
            :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
            label="Инициатор события"
            :value="dataSource.eventData && dataSource.eventData.authorTitle"
            :readonly="true"
        />
      </div>
    </div>
    <ObInput
      label="Адрес точки"
      :value="dataSource.point && dataSource.point.addressTitle"
      pre-icon="pin"
      :readonly="true"
      class="mb10"
    />
    <ObInput
      label="Грузоотправитель"
      :value="dataSource.point && dataSource.point.title"
      :readonly="true"
    />
    <div class="title">Укажите дату и время начала ПРР</div>
    <div class="row">
      <div class="col-xs-6">
        <ObDatePickerConstructor
          :value="formData.specialParameters && formData.specialParameters.eventDt"
          label="Начало ПРР"
          :is-time="true"
          :readonly="!isNew && !isNewForm"
          @input="onChangeField('specialParameters.eventDt', $event)"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ObTextarea
          :value="formData.eventData && formData.eventData.comment"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="!isNew && !isNewForm"
          @input="onChangeField('eventData.comment', $event)"
        />
      </div>
    </div>
    <template v-if="formData.eventData && (!formData.eventData.fileUuids || !formData.eventData.fileUuids.length) && isEditMode && !isNewForm">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-if="(formData.eventData && formData.eventData.fileUuids && formData.eventData.fileUuids.length) || isNew || isNewForm">
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFiles"
        data-qa="uploader"
        :is-read-only="!isNew && !isNewForm"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'

export default {
  name: 'defectEventForm',
  components: {
    ObInput,
    ObTextarea,
    ObUploader,
    ObDatePickerConstructor
  },
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    },
    isNewForm: {
      type: Boolean,
      default: false
    },
    dataSource: {
      type: Object,
      default: () => {}
    }
  },
  watch: {
    'formData.eventData.fileUuids'(value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    uploadMethod () {
      return api.files.postFile
    },
    currentFiles () {
      return this.dataSource.filesData
    }
  },
  methods: {
    startUploadFiles () {
      this.formData.eventData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.onChangeField('eventData.fileUuids', null)
        return
      }

      this.onChangeField('eventData.fileUuids', data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    },
    async getForwardingUnits ({ query, page, size }) {
      const res = await api.resources.getForwardingUnitList(page, size, query)
      return res.data
    }
  }
}
</script>

<style lang="scss" scoped>
  .row-input {
    margin-right: 0;
    margin-left: 0;
    flex-wrap: nowrap;
    &__item {
      width: 212px;
      flex-grow: 2;
      &:not(:last-child) {
        margin-right: 10px;
      }
    }
    &__counter {
      width: 135px;
    }
  }

  .mb10 {
    margin-bottom: 10px !important;
  }
</style>